
#include <hmg.ch>

//REQUEST DBFCDX, DBFFPT  // uncomment to enable dbfcdx driver



*************
function Main

   PRIVATE cAppHome    := LOWER( GETSTARTUPFOLDER() )
   PRIVATE cHomeFolder := cAppHome

   PRIVATE dbMain := cHomeFolder + "\" + "sample"
   PRIVATE ixMain := cHomeFolder + "\" + "sampledate"

   PRIVATE acHeaders_ := { "Date", "First Name", "Last Name" }
   PRIVATE anWidths_  := { 100, 150, 150 }
   PRIVATE acFields_  := { "SAMPLE->DATE", "SAMPLE->FNAME", "SAMPLE->LNAME" }
   
   PRIVATE cFilter

   //ANNOUNCE RDDSYS     // this one
   SET FIXED ON
   SET DECIMALS TO 2
   SET MULTIPLE OFF WARNING
   SET DATE AMERICAN
   SET CENTURY ON
   SET EPOCH TO 1950
   SET WRAP ON
   SET SCOREBOARD OFF
   SET DELETED ON
   SET CONFIRM ON
   SET BELL ON
   SET FONT TO "Verdana" , 9
   SET NAVIGATION EXTENDED
   SET BROWSESYNC ON
   SET TOOLTIPSTYLE BALLOON
   SET TOOLTIPBACKCOLOR { 255 , 255 , 255 }
   SET TOOLTIPFORECOLOR { 0 , 0 , 0 }
   //RDDSETDEFAULT("DBFCDX")    // and this!
   
   MakeFile()
   IF .NOT. OpenTable()
      MSGSTOP( "Database file is not available.", "Error" )
      RETURN NIL
   ENDIF

   DEFINE WINDOW frmGenBrowse;
      AT 0,0;
      WIDTH 730 HEIGHT 540;
      TITLE "Browse Test";
      ; //ICON ::cImageHome + "window.ico";
      MAIN;
      ; //NOMINIMIZE NOMAXIMIZE NOSIZE;
      FONT "Arial" SIZE 9;
      ON INIT ( winAutoAdjust( "frmGenBrowse" ), BrowseStatusChanged() )  ;
      ON SIZE winAutoAdjust( "frmGenBrowse" ) ;
      ON MAXIMIZE winAutoAdjust( "frmGenBrowse" ) ;
      ON RELEASE DBCLOSEALL();
      ON INTERACTIVECLOSE NIL

      ON KEY ESCAPE OF frmGenBrowse ACTION frmGenBrowse.Release

      DEFINE TOOLBAR tBarBrowse OF frmGenBrowse BUTTONSIZE 24, 24 FONT "Arial" SIZE 8 BORDER
         BUTTON tbtnNExit CAPTION "E&xit" PICTURE "HP_CLOSE";
            ACTION frmGenBrowse.Release
         BUTTON tbtnNew  CAPTION "&New Record" PICTURE "HMG_EDIT_NEW";
            ACTION MSGINFO( "Your GUI to create new record", "Test" )
            
         BUTTON tbtnEdit CAPTION "E&dit Record" PICTURE "HMG_EDIT_EDIT";
            ACTION MSGINFO( "Your GUI to edit the current record", "Test" )
            
         BUTTON tbtnDel CAPTION "Delete Record" PICTURE "HMG_EDIT_DELETE";
            ACTION MSGINFO( "Your UDF to delete the current record", "Test" )
            
         BUTTON tbtnPrint CAPTION "&Print" PICTURE "HMG_EDIT_PRINT";
            ACTION MSGINFO( "Your printing module", "Test" )
      END TOOLBAR

      DEFINE STATUSBAR FONT "Arial" SIZE 8
         STATUSITEM " " + ALLTRIM( ALIAS() ) WIDTH 100 ACTION NIL // ICON ImageHome + "child.ico"
         STATUSITEM "Index: " WIDTH 150
         STATUSITEM "Key: " + INDEXKEY() WIDTH 150
         STATUSITEM "Deleted: " WIDTH 80
         STATUSITEM "" WIDTH 130 RAISED
         STATUSITEM "" WIDTH 130
      END STATUSBAR
         
      DEFINE MAIN MENU
         DEFINE POPUP "&File"
            ITEM "E&xit" ACTION frmGenBrowse.Release
         END POPUP
         DEFINE POPUP "&Filter"
            ITEM "OrdScope()" ACTION setScope()  NAME mnSetScope
            ITEM "Clear Scope" ACTION noScope() NAME mnNoScope
            SEPARATOR
            ITEM "Set Filter" ACTION setFilter() NAME mnSetF
            ITEM "Clear Filter" ACTION clearFilter() NAME mnClearF
         END POPUP
      END MENU         
         
      @  47,  4 BROWSE brwTable OF frmGenBrowse WIDTH  714 HEIGHT 360; 
         HEADERS acHeaders_ WIDTHS anWidths_ WORKAREA SAMPLE FIELDS acFields_;
         TOOLTIP "";
         VALUE ( RECNO() ) FONT "Arial" SIZE 9 ON CHANGE BrowseStatusChanged();
         ON DBLCLICK MSGINFO( "Current Record: " + HB_NTOS( RECNO() ) + " - " + DTOC( SAMPLE->DATE ), "Test" ); 
         ON HEADCLICK NIL 

               
      @ 409,212 BUTTON btnNew OF frmGenBrowse CAPTION "&New"; 
         ACTION MsgInfo( "Add New Record", "test" );
         WIDTH  100 HEIGHT 28
         
      @ 409,312 BUTTON btnEdit OF frmGenBrowse CAPTION "&Edit"; 
         ACTION MsgInfo( "Edit Record", "Test" );
         WIDTH  100 HEIGHT 28
         
      @ 409,412 BUTTON btnDelete OF frmGenBrowse CAPTION "&Delete"; 
         ACTION MsgInfo( "Delete Record", "Test" );
         WIDTH  100 HEIGHT 28
         
      @ 409,512 BUTTON btnPrint OF frmGenBrowse CAPTION "&Print"; 
         ACTION MsgInfo( "No printing module yet.", "Test" );
         WIDTH  100 HEIGHT 28
         
      @ 409,612 BUTTON btnExit OF frmGenBrowse CAPTION "E&xit"; 
         ACTION frmGenBrowse.Release;
         WIDTH  100 HEIGHT 28
         
      @ 440,  4 LABEL lblQuickDummy OF frmGenBrowse VALUE "" ACTION NIL;
         WIDTH 73 HEIGHT 22 FONT "Arial" Size 9 BACKCOLOR { 051, 000, 000 } FONTCOLOR { 255, 255, 255 } CENTERALIGN
         
      @ 443,  4 LABEL lblQuickFind OF frmGenBrowse VALUE "&Quick Find:" ACTION NIL;
         WIDTH 73 HEIGHT 18 FONT "Arial" Size 9 BACKCOLOR { 051, 000, 000 } FONTCOLOR { 255, 255, 255 } CENTERALIGN
         
      @ 439, 78 TEXTBOX txbQuickFind OF frmGenBrowse HEIGHT 24 VALUE "" WIDTH 640;
         FONT "Arial" SIZE 9  TOOLTIP "Quick search, enter the value that you would like to search";
         MAXLENGTH 300 ON CHANGE QuickFindChanged() ON LOSTFOCUS QFindLostfocus() ON ENTER NIL       
         
   END WINDOW

   **-- Disable SetScope and Clear Filter
   frmGenBrowse.mnNoScope.Enabled := .f.
   frmGenBrowse.mnClearF.Enabled := .f.
   
   frmGenBrowse.Center
   frmGenBrowse.Activate
   RETURN NIL


*************************************
static function BrowseStatusChanged()

   frmGenBrowse.Statusbar.Item(4) := "Deleted: " + IF( DELETED(), "Yes", "No" )
   frmGenBrowse.Statusbar.Item(5) := "Record No.: " + ALLTRIM( STR( RECNO() ) )
   frmGenBrowse.Statusbar.Item(6) := "No. of Records: " + ALLTRIM( STR( LASTREC() ) )
   RETURN NIL



**********************************
static function QuickFindChanged()

   LOCAL cSearchKey := UPPER( ALLTRIM( frmGenBrowse.txbQuickFind.Value ) )
   LOCAL nCurrentRecPos := RECNO()

   DBSEEK( cSearchKey )
   IF EOF()
      DBGOTO( nCurrentRecPos )
   ENDIF
   BrowseStatusChanged()
   frmGenBrowse.brwTable.Value := RECNO()
   frmGenBrowse.brwTable.Refresh
   RETURN NIL




********************************
static function QFindLostfocus()

   LOCAL nRecPosition := RECNO()

   frmGenBrowse.txbQuickFind.Value := ""
   frmGenBrowse.brwTable.Setfocus()
   frmGenBrowse.brwTable.Refresh
   frmGenBrowse.brwTable.Value := nRecPosition
   frmGenBrowse.brwTable.Refresh
   RETURN NIL





**************************
static function MakeFile()

   IF .NOT. FILE( "&dbMain" + ".dbf" )
      DBCREATE( ( dbMain + ".dbf" ), ;
                { { "Date" , "D",  8, 0 },;
                  { "FName", "C", 20, 0 },;
                  { "LName", "C", 20, 0 } }, RDDSETDEFAULT() )
   ENDIF
   IF .NOT. FILE( "&ixMain" + ".ntx" )
      USE ( dbMain ) ALIAS SAMPLE EXCLUSIVE NEW VIA RDDSETDEFAULT()
      INDEX ON DTOS( Date ) TO SAMPLEDATE
      SET INDEX TO SAMPLEDATE
      tblPopulate()
   ELSE
      USE ( dbMain ) ALIAS SAMPLE EXCLUSIVE NEW VIA RDDSETDEFAULT()
      SET INDEX TO ( ixMain )
      REINDEX
   ENDIF
   SAMPLE->( DBCLOSEAREA() )
   RETURN NIL




***************************
static function OpenTable()

   LOCAL lRetVal := .f.

   BEGIN SEQUENCE
   USE ( dbMain ) ALIAS SAMPLE EXCLUSIVE NEW VIA RDDSETDEFAULT()
   IF NETERR()
      BREAK
   ENDIF
   SET INDEX TO SAMPLEDATE
   DBGOTOP()
   lRetVal := .t.
   END SEQUENCE
   RETURN lRetVal



*****************************
static function tblPopulate()

   LOCAL ii := 1
   LOCAL nDateCount := 6
   
   LOCAL dStart := CTOD( "01/01/2013" )
   LOCAL cFirst := ""
   LOCAL cLast  := ""

   DBSELECTAREA( "SAMPLE" )
   FOR ii := 1 TO 200
      IF nDateCount > 5
         nDateCount := 1
         // dStart++ // uncomment to allow duplicate dates and comment-out dStart++ variable below
      ENDIF 

      cFirst := DummyName()
      INKEY( .03)
      cFirst += LOWER( REPLICATE( DummyName(), 19 ) )
      INKEY(.02)
      cLast  := DummyName()
      INKEY( .03 )
      cLast  += LOWER( REPLICATE( DummyName(), 19 ) )
      INKEY(.02)

      DBAPPEND()
      FIELDPUT( 1, dStart )   // replace date with dStart
      FIELDPUT( 2, cFirst )   // replace fname with cFirst
      FIELDPUT( 3, cLast  )   // replace lname with cLast

      dStart++         // put comment to allow duplicate dates
      nDateCount++     // this is similar to: nDateCount := nDateCount + 1, just shortcut inheritted by Clipper from C
   NEXT
   DBCOMMITALL()
   RETURN NIL




***************************
static function DummyName()

   LOCAL aAlpha_ := { "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T",;
                      "U", "V", "W", "X", "Y", "Z" }

   LOCAL cRetVal := ""
   LOCAL ii
   LOCAL nRand := 0

   cRetVal += aAlpha_[ RandomNbr( 26 ) ]   // returns random number between 1 and 26
   RETURN cRetVal



******************************
static function RandomNbr( n )  // this not a high precission random number generator

   LOCAL nRetVal

   STATIC nSeed := .123456789

   nSeed := SECONDS()/100000
   nSeed := ( nSeed * 98314.9743 + .2198341 ) % 1 
   nRetVal := ( INT( nSeed * n ) )
   IF nRetVal = 0
      nRetVal := 1
      ELSEIF nRetVal > n
         nRetVal := n - 1
      ELSEIF nRetVal < 1
         nRetVal *= -1
         IF nRetVal > n
            nRetVal := n - 1
         ELSE
            IF nRetVal = 0
               nRetVal := 1
            ENDIF
         ENDIF
   ENDIF
   RETURN nRetVal




**************************
static function setScope()

   LOCAL aDateRange_ := {}

   PRIVATE cTop := ""
   PRIVATE cBot := ""

   BEGIN SEQUENCE
   aDateRange_ := selectDateRange( )
   IF EMPTY( aDateRange_ )
      BREAK
   ENDIF
   cTop := DTOS( aDateRange_[ 1 ] )   // From Date
   cBot := DTOS( aDateRange_[ 2 ] )   // To Date
   ORDSCOPE( 0, "&cTop" )
   ORDSCOPE( 1, "&cBot" )
   DBGOTOP()
   frmGenBrowse.mnSetScope.Enabled := .f.
   frmGenBrowse.mnNoScope.Enabled  := .t.
   frmGenBrowse.brwTable.Value := &( ALIAS() )->( RECNO() )
   frmGenBrowse.brwTable.Refresh
   frmGenBrowse.brwTable.Setfocus
   END SEQUENCE 
   RETURN NIL


*************************
static function noScope()

   LOCAL nRecPos := RECNO()  // save record pointer position
   
   ORDSCOPE( 0, NIL )
   ORDSCOPE( 1, NIL )
   DBGOTOP()
   IF nRecPos > 0
      DBGOTO( nRecPos )
      frmGenBrowse.brwTable.Value := &( ALIAS() )->( RECNO() )
      frmGenBrowse.brwTable.Setfocus
   ENDIF      
   frmGenBrowse.brwTable.Refresh
   frmGenBrowse.mnSetScope.Enabled := .t.
   frmGenBrowse.mnNoScope.Enabled  := .f.
   RETURN NIL




***************************
static function setFilter()

   LOCAL aDateRange_ := {}

   PRIVATE cTop := ""
   PRIVATE cBot := ""

   BEGIN SEQUENCE
   aDateRange_ := selectDateRange( 2 )
   IF EMPTY( aDateRange_ )
      BREAK
   ENDIF
   cTop := DTOS( aDateRange_[ 1 ] )   // From Date
   cFilter := SUBSTR( cTop, 1, 6 )
   SET FILTER TO cFilter = SUBSTR( DTOS( DATE ), 1, 6 )
   frmGenBrowse.mnSetF.Enabled := .f.
   frmGenBrowse.mnClearF.Enabled  := .t.
   frmGenBrowse.brwTable.Value := &( ALIAS() )->( RECNO() )
   frmGenBrowse.brwTable.Refresh
   frmGenBrowse.brwTable.Setfocus
   END SEQUENCE 
   RETURN NIL



*****************************
static function clearFilter()

   LOCAL nRecPos := RECNO()  // save record pointer position
   
   SET FILTER TO   
   DBGOTOP()
   IF nRecPos > 0
      DBGOTO( nRecPos )
      frmGenBrowse.brwTable.Value := &( ALIAS() )->( RECNO() )
      frmGenBrowse.brwTable.Setfocus
   ENDIF      
   frmGenBrowse.brwTable.Refresh
   frmGenBrowse.mnSetF.Enabled := .t.
   frmGenBrowse.mnClearF.Enabled  := .f.
   SET SOFTSEEK OFF
   RETURN NIL



*************************************************************************************
** Add External .prg module as part of the Apps
** IF Hmg-IDE and or hbmk2 and .hbp file is used, this include def should be removed;
**    and must be added to .hbp file for hbmk2
*************************************************************************************
#include <winAutoAj.prg>
#include <daterange.prg>
