#include <hmg.ch>


************************
Function ISAPPXPTHEMED()
   RETURN ( OS_ISWINXP_OR_LATER() .AND. IsAppThemed() )


*****************************************************
function winAutoAdjust( cForm )   // public interface

   _winAutoAdjust( ( GetFormHandle( cForm ) ) )
   RETURN NIL



*******************************
static function _winAutoAdjust( hWnd )

   LOCAL i, k, ParentForm, ControlCount, ControlName, ControlType, nWidth, nHeight, lvisible:=.T., nDivw, nDivh
   altd()
   IF GetDesktopWidth() < GetWindowWidth ( hWnd )
      nWidth := GetDesktopWidth()
   ELSE
      nWidth := GetWindowWidth ( hWnd )
   ENDIF
   
   IF GetDesktopHeight() < GetWindowHeight ( hWnd )
      nHeight := GetDesktopHeight()
   ELSE
      nHeight := GetWindowHeight ( hWnd )
   ENDIF
   
   IF IsWindowVisible ( hWnd ) .And. ! IsAppXPThemed()
      HideWindow ( hWnd )
   ELSE
      lvisible := .F.
   ENDIF
   
   i := aScan ( _HMG_SYSDATA[67] , hWnd )
   ParentForm := _HMG_SYSDATA[66] [i]
   
   if _HMG_SYSDATA[92] [i] > 0 .and. _HMG_SYSDATA[91] [i] > 0
      nDivw := nWidth / _HMG_SYSDATA[92] [i]
      nDivh := nHeight / _HMG_SYSDATA[91] [i]
   else
      nDivw := 1
      nDivh := 1
   endif
   
   ControlCount := Len ( _HMG_SYSDATA[3] )
   
   For k := 1 To ControlCount
      ControlName := _HMG_SYSDATA[2] [k]
      if _IsControlDefined ( ControlName, ParentForm )
         ControlType := _HMG_SYSDATA[1] [k]
         if !Empty( ControlName ) .And. !( ControlType $ "MENU,HOTKEY,TOOLBAR,MESSAGEBAR,ITEMMESSAGE,TIMER" ) //.And.;
            DO CASE
               CASE ControlType == "RADIOGROUP"
                  _HMG_aControlSpacing     := _HMG_SYSDATA[ 22 ]
                  _HMG_aControlMiscData1   := _HMG_SYSDATA[  8 ]
                  _HMG_aControlSpacing [k] := _HMG_aControlSpacing [k] * iif(_HMG_aControlMiscData1 [k], nDivw, nDivh)
                  
               CASE ControlType == "SLIDER"     // do nothing
               CASE ControlType == "STATUSBAR"  // do nothing
               CASE ControlType == "BUTTON"
                  _SetControlSizePos ( ControlName, ParentForm,;
                  _GetControlRow ( ControlName, ParentForm ) * nDivh, _GetControlCol ( ControlName, ParentForm ) * nDivw,;
                  _GetControlWidth ( ControlName, ParentForm ) * nDivw, _GetControlHeight ( ControlName, ParentForm ) * nDivh )

               CASE !ControlType $ "TOOLBUTTON"
                  _SetControlSizePos ( ControlName, ParentForm,;
                  _GetControlRow ( ControlName, ParentForm ) * nDivh, _GetControlCol ( ControlName, ParentForm ) * nDivw,;
                  _GetControlWidth ( ControlName, ParentForm ) * nDivw, _GetControlHeight ( ControlName, ParentForm ) * nDivh )
            OTHERWISE
               if empty(_HMG_SYSDATA[28] [k] )
                     _SetFontSize ( ControlName, ParentForm , 8 * nDivh )
               else
                     _SetFontSize ( ControlName, ParentForm , _HMG_SYSDATA[28] [k] * nDivh )
               endif
            ENDCASE
         endif
      endif
   Next k
   _HMG_SYSDATA[92]  [i] := nWidth
   _HMG_SYSDATA[91] [i] := nHeight
   IF lvisible
      ShowWindow ( hWnd )
   ENDIF
   RETURN nil